import os
import sys
import time
import warnings
import pandas as pd

from dl.dl_model import TA_keras





warnings.filterwarnings("ignore")
from tensorflow.core.protobuf.config_pb2 import ConfigProto
from tensorflow.python.client.session import InteractiveSession
from config.config import Config
from data.data import get_single_data

from tools.tools import get_label, score2, set_global_determinism

import pickle as pkl
os.environ['TF_XLA_FLAGS'] = '--tf_xla_enable_xla_devices'
config1 = ConfigProto()
config1.gpu_options.allow_growth = True
session = InteractiveSession(config=config1)


if __name__ == "__main__":
    sys.setrecursionlimit(15000)
    start = time.time()
    SEED = 0
    set_global_determinism(SEED)


    dataset = "ac4c"

    original_train1, original_test1 = get_single_data(dataset)  # DataFrame with 2 columns (label, seq)
    train_label1 = get_label(original_train1)
    test_label1 = get_label(original_test1)



    with open("result/fake_data_bn.pkl", "rb") as f:
        dataset_fake = pkl.load(f)

    for i in range(20):
        # real_neg = original_train1.iloc[train_label1==0,:]
        # data_train3 = pd.concat([dataset_fake[i],real_neg])
        data_train3 = dataset_fake[i]
        print("data_train3:",data_train3.shape)
        y_train3 = get_label(data_train3)

        # use the fake DNA to pretrain CNN
        config_global = Config()
        config_global.model_name = dataset+str(i) + "_fake"
        config_global.model_save_path = "result/"  # "data/global_pretrain_model_group1.model"
        config_global.load_global_pretrain_model = False
        sm = TA_keras(config_global)
        sm.fit(data_train3, y_train3)
        pred_prob = sm.predict_proba(original_test1)
        result_temp = score2(test_label1, pred_prob)
        print("fake:",dataset, result_temp)

        #--------------------------------
        set_global_determinism(SEED)
        # use the fake DNA to pretrain CNN
        config_global = Config()
        config_global.model_name = dataset + "_temp"
        config_global.model_save_path = "result/"  # "data/global_pretrain_model_group1.model"
        config_global.load_global_pretrain_model = False
        config_global.global_model_save_path = config_global.model_save_path + dataset+"_fake"+"_.h5"

        sm = TA_keras(config_global)
        sm.fit(original_train1, train_label1)
        pred_prob = sm.predict_proba(original_test1)
        result_temp = score2(test_label1, pred_prob)
        print("no tran:", dataset, result_temp)

        #-------------------------------
        set_global_determinism(SEED)
        # use the fake DNA to pretrain CNN
        config_global = Config()
        config_global.model_name = dataset + "_temp"
        config_global.model_save_path = "result/"  # "data/global_pretrain_model_group1.model"
        config_global.load_global_pretrain_model = True
        config_global.global_model_save_path = config_global.model_save_path +dataset+str(i) + "_fake_.h5"


        sm = TA_keras(config_global)
        sm.fit(original_train1, train_label1)
        pred_prob = sm.predict_proba(original_test1)
        result_temp = score2(test_label1, pred_prob)
        print("tran:",dataset,result_temp)

        end = time.time()
        print("Time consuming:%.2f秒" % (end - start))

